;  
;
; +---------------------+
; |   |
; +---------------------+
.equ   MOSIPORT=PORTB   ;      MOSI ( DI)
.equ   MOSIPIN =5       ;   

.equ   CLKPORT =PORTB   ;      CLK (SCK, CLOCK)
.equ   CLKPIN  =7       ;   

.equ   DCPORT  =PORTB   ;      DC (D/C)
.equ   DCPIN   =6       ;   

.equ   RSTPORT =PORTB  ;      RST (RES, RESET)
.equ   RSTPIN  =4      ;   

;  SCE (CS)     !

; +---------------------+
; |   |
; +---------------------+
;
.MACRO INITPORT
;        !!
          INITONE   ;      LCD    
;          INITMULT  ;      LCD    
.ENDMACRO

; +-----------------------------------------------------------+
; |                                                           |
; |  !!!      !!! |
; |                                                           |
; +-----------------------------------------------------------+
; --------------------------------------------------------------------   
.MACRO    INITONE		;    LCD      
						LDI		R16 , (1<<MOSIPIN)|(1<<CLKPIN)|(1<<DCPIN)|(1<<RSTPIN)
						out		MOSIPORT	, R16
.ENDMACRO

.MACRO    INITMULT      ;   LCD      
						ldi		R16 , (1<<MOSIPIN)
						out		MOSIPORT	, R16
						ldi		R16 , (1<<CLKPIN)
						out		CLKPORT	, R16
						ldi		R16 , (1<<DCPIN)
						out		DCPORT	, R16
						ldi		R16 , (1<<RSTPIN)
						out		RSTPORT	, R16
.ENDMACRO
; -------------------------------------------------------------------------------------------


LCD_INIT:	; --------------------------------------------------------------  SPI 
             
;						INITPORT  ;     SPI

						LDI		R16 , (1<<MOSIPIN)|(1<<CLKPIN)|(1<<DCPIN)|(1<<RSTPIN)
						out		MOSIPORT	, R16

						cbi   RSTPORT , RSTPIN    ; RST=0
						nop
						sbi   RSTPORT , RSTPIN    ; RST=1

						cbi   DCPORT , DCPIN      ; DC=0 -  

						ldi		ZL	, low (LCD_INIT_STR*2)
						ldi		ZH	, high(LCD_INIT_STR*2)
						ldi		R17	, 8
init_loop:
						lpm		R16	, Z+
						rcall 	LCD_SENDBYTE
						dec		R17
						brne	init_loop                        

						sbi   DCPORT , DCPIN       ; DC=1  

						clr		R16        ;  
						ldi		R17	, 252
LCD_CLR_LOOP:			rcall	LCD_SENDBYTE
						rcall	LCD_SENDBYTE
						DEC		R17
						BRNE	LCD_CLR_LOOP

                        ret 
   					    ;  
LCD_INIT_STR:			.DB 0x21, 0xC2, 0x06, 0x13, 0x20, 0x0C, 0x80, 0x40
					    

LCD_POS: 	;-------------------------------------------------  (R17=X  R18=Y)
                        push    R16
                        ldi     R16 , 0x80
						add     R16 , R17    ; X
						cbi   PORTB , 6    ; DC=0
						rcall	LCD_SENDBYTE
                        ldi     R16 , 0x40
						add     R16 , R18    ; Y
						rcall	LCD_SENDBYTE
						sbi   PORTB , 6    ; DC=0
						pop		R16
						ret


LCD_SENDBYTE:	;----------------------------------------     (R16 )
                        push  R17
						push  R16
				        ldi   R17 , 8
LCD_SENDBYTE_loop:
						cbi		CLKPORT  , CLKPIN    ; sck=0
                        cbi		MOSIPORT , MOSIPIN   ; mosi=0
						sbrc	R16 , 7
                        sbi		MOSIPORT , MOSIPIN   ; mosi=1
						sbi		CLKPORT  , CLKPIN    ; sck=1
                        rol		R16
						dec		R17
						brne	LCD_SENDBYTE_loop
                        cbi		MOSIPORT , MOSIPIN   ; mosi=0
						pop		R16
                        pop		R17
						ret

LCD_CHAR:	; ---------------------------------------------------   (R16 - )
                        push    R17
						LDI		ZL	, low (charset*2)
						LDI		ZH	, high(charset*2)
						LDI		R17	, 4
						MUL		R17	, R16
						ADD		ZL	, R0
						ADC		ZH	, R1
						sbi   PORTB , 6    ; DC=1
LCD_CHAR_LOOP:          ;  
						LPM		R16	, Z+
						RCALL	LCD_SENDBYTE
						DEC		R17
						BRNE	LCD_CHAR_LOOP
						CLR		R16				;   
						RCALL	LCD_SENDBYTE
						pop     R17
						RET


charset:	;    
                       	.db 0x3E, 0x41, 0x41, 0x3E   ; 0
        				.db 0x44, 0x42, 0x7F, 0x40   ; 1
						.db 0x42, 0x61, 0x51, 0x4E   ; 2
						.db 0x22, 0x41, 0x49, 0x36   ; 3
						.db 0x1C, 0x12, 0x79, 0x10   ; 4
						.db 0x27, 0x45, 0x45, 0x39	 ; 5
						.db 0x3E, 0x49, 0x49, 0x32	 ; 6
						.db 0x01, 0x71, 0x09, 0x07	 ; 7
						.db 0x36, 0x49, 0x49, 0x36	 ; 8
						.db 0x26, 0x49, 0x49, 0x3E	 ; 9
						.db 0x7C, 0x12, 0x11, 0x7E	 ; A
						.db 0x7F, 0x49, 0x49, 0x36	 ; B
        				.db 0x3E, 0x41, 0x41, 0x22	 ; C
        				.db 0x7F, 0x41, 0x22, 0x1C   ; D 
        				.db 0x7F, 0x49, 0x49, 0x49	 ; E
						.db 0x7F, 0x09, 0x09, 0x01   ; F
        				.db 0x00, 0x00, 0x00, 0x00	 ; 
